package main

import (
	"testing"
	"gitlab.smartblocklab.com/smartcontracts/common/security/actions"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"github.com/stretchr/testify/assert"
)

func TestFindSecurityPreferenceByFunctionName_ClearLedger(t *testing.T) {
	preference, err := actions.FindSecurityPreferenceByFunctionName(invoke.EthereumInputCC, invoke.ClearLedger)
	assert.NoError(t, err)
	assert.NotNil(t, preference)
	print(preference.ParameterType)
}

func TestFindSecurityPreferenceByFunctionName_Ping(t *testing.T) {
	preference, err := actions.FindSecurityPreferenceByFunctionName(invoke.EthereumInputCC, invoke.Ping)
	assert.NoError(t, err)
	assert.NotNil(t, preference)
	print(preference.ParameterType)
}

func TestFindSecurityPreferenceByFunctionName_AddKeyValue(t *testing.T) {
	preference, err := actions.FindSecurityPreferenceByFunctionName(invoke.EthereumInputCC, invoke.AddKeyValueFunction)
	assert.NoError(t, err)
	assert.NotNil(t, preference)
	print(preference.ParameterType)
}

func TestFindSecurityPreferenceByFunctionName_AddKeyValueArray(t *testing.T) {
	preference, err := actions.FindSecurityPreferenceByFunctionName(invoke.EthereumInputCC, invoke.AddKeyValueArrayFunction)
	assert.NoError(t, err)
	assert.NotNil(t, preference)
	print(preference.ParameterType)
}

func TestFindSecurityPreferenceByFunctionName_GetKeyValue(t *testing.T) {
	preference, err := actions.FindSecurityPreferenceByFunctionName(invoke.EthereumInputCC, invoke.GetKeyValueFunction)
	assert.NoError(t, err)
	assert.NotNil(t, preference)
	print(preference.ParameterType)
}

func TestFindSecurityPreferenceByFunctionName_GetKeyValueArray(t *testing.T) {
	preference, err := actions.FindSecurityPreferenceByFunctionName(invoke.EthereumInputCC, invoke.GetKeyValueArrayFunction)
	assert.NoError(t, err)
	assert.NotNil(t, preference)
	print(preference.ParameterType)
}

