package mngr

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/model/keyValueCC"
)

func (this KeyValueManagerImpl) GetKeyValueArray(keyArrayId *requests.ArrayId) (*keyValueCC.KeyValueArray, error) {
	result := &keyValueCC.KeyValueArray{}
	result.KeyValue = []keyValueCC.KeyValue{}

	for _, key := range keyArrayId.ArrayId {
		validObject, err := this.GetObject(&keyValueCC.KeyValue{}, key.Id)
		if err != nil {
			return nil, err
		}

		keyValue, err := keyValueCC.Cast(validObject)
		if err != nil {
			return nil, err
		}

		result.KeyValue = append(result.KeyValue, *keyValue)
	}

	return result, nil
}
