package iuser

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/userCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type IUserManager interface {
	// invoke
	AddRootUser(user *userCC.User) (chaincode.ValidObject, error)
	AddOrganizationRootUser(user *userCC.User) (chaincode.ValidObject, error)
	AddSystemUser(user *userCC.User) (chaincode.ValidObject, error)
	AddServiceUser(user *userCC.User) (chaincode.ValidObject, error)
	AddUser(user *userCC.User) (chaincode.ValidObject, error)
	AddPublicKey(addPublicKeyArg userCC.AddPublicKeyArg) (chaincode.ValidObject, error)
	RevokeUserPublicKey(revokeUserPublicKeyArg userCC.RevokeUserPublicKeyArg) (chaincode.ValidObject, error)
	// query
	GetUser(userID *requests.Id) (*userCC.User, error)
	VerifyUserSignature(verifyUserSignatureArg requests.VerifyUserSignatureArg) (chaincode.ValidObject, error)
}
