package actions

import "gitlab.smartblocklab.com/smartcontracts/common/invoke"

// common method

const ping = "ping"
const clearLedger = "clearLedger"



var SecurityPreferenceArray = []SecurityPreference{
	// Common
	// invoke

	// ping
	SecurityPreference{invoke.AccountCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptocurrencyCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OrganizationCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserpreferenceCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystempreferenceCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicepreferenceCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcesstypecryptocurrencyCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptocurrencyconstraintCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},


	// clearLedger
	SecurityPreference{invoke.AccountCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptocurrencyCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OrganizationCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserpreferenceCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystempreferenceCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicepreferenceCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcesstypecryptocurrencyCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptocurrencyconstraintCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// AccountCC

	// invoke
	SecurityPreference{invoke.AccountCC, invoke.AddWalletFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.AddAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.ActivateWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.BlockWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.ActivateAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.BlockAccountFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.AccountCC, invoke.GetAccountByCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.VerifyUserAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.CheckAndLoadAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAllUserWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAccountInfoByAccountIDFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAccountsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// MarketaccountCC

	// invoke
	SecurityPreference{invoke.MarketaccountCC, invoke.AddWalletFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.AddAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.ActivateWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.BlockWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.ActivateAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.BlockAccountFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAccountByCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.VerifyUserAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.CheckAndLoadAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAllUserWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAccountInfoByAccountIDFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAccountsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// AuthCC

	// invoke
	SecurityPreference{invoke.AuthCC, invoke.AddAuthInfoFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, invoke.UpdateAuthInfoFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.AuthCC, invoke.GetAuthInfoFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// CommissionCC

	// invoke
	SecurityPreference{invoke.CommissionCC, invoke.AddCommissionFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, invoke.UpdateCommissionFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.CommissionCC, invoke.GetCommissionFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// CryptocurrencyCC

	// invoke
	SecurityPreference{invoke.CryptocurrencyCC, invoke.AddCryptocurrenciesFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptocurrencyCC, invoke.ClearTransferredCryptocurrencyListFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.CryptocurrencyCC, invoke.GetCryptocurrenciesByDaemonNameFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// OfferCC

	// invoke
	SecurityPreference{invoke.OfferCC, invoke.AddOfferFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.UpdateOfferFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.SetOfferStatusByOperationIdFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.PutOfferPropertiesByOperationIdFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.OfferCC, invoke.GetOfferFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetRequestsByStatusFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetUserIncomingRequestsByStatusFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetUserOutgoingRequestsByStatusFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetHistoryUserIncomingRequestsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetHistoryUserOutgoingRequestsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.IsOfferApprovedFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetRequestsByStatusAndCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// ExternalOfferCC

	// invoke
	SecurityPreference{invoke.ExternalOfferCC, invoke.AddOfferFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.UpdateOfferFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.SetOfferStatusByOperationIdFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.PutOfferPropertiesByOperationIdFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetOfferFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetRequestsByStatusFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetUserIncomingRequestsByStatusFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetUserOutgoingRequestsByStatusFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetHistoryUserIncomingRequestsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetHistoryUserOutgoingRequestsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.IsOfferApprovedFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ExternalOfferCC, invoke.GetRequestsByStatusAndCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// TransactionCC

	// invoke
	SecurityPreference{invoke.TransactionCC, invoke.LockFundsOnAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LockOutFundsOnAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.TransferFundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.UnlockFundsOnAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LoadCryptocurrencyFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LockTransferToMarketFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LoadMarketFoundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.WithdrawalMarketFundsFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.TransactionCC, invoke.CheckExistsTransactionByListFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.GetUsersTransactionFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.AccountCurrencyBalanceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// UserCC

	// invoke
	SecurityPreference{invoke.UserCC, invoke.AddRootUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddOrganizationRootUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddSystemUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddServiceUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddPublicKeyFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.RevokeUserPublicKeyFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.UserCC, invoke.GetUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.VerifyUserSignatureFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// OrganizationCC

	// invoke
	SecurityPreference{invoke.OrganizationCC, invoke.AddOrganizationFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.OrganizationCC, invoke.GetOrganizationFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// SessionCC

	// invoke
	SecurityPreference{invoke.SessionCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.SessionCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// UserpreferenceCC

	// invoke
	SecurityPreference{invoke.UserpreferenceCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserpreferenceCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.UserpreferenceCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// DevicepreferenceCC

	// invoke
	SecurityPreference{invoke.DevicepreferenceCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicepreferenceCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.DevicepreferenceCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// SystempreferenceCC

	// invoke
	SecurityPreference{invoke.SystempreferenceCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystempreferenceCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.SystempreferenceCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// ProcesstypecryptocurrencyCC

	// invoke
	SecurityPreference{invoke.ProcesstypecryptocurrencyCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcesstypecryptocurrencyCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.ProcesstypecryptocurrencyCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// CryptocurrencyconstraintCC

	// invoke
	SecurityPreference{invoke.CryptocurrencyconstraintCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptocurrencyconstraintCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.CryptocurrencyconstraintCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycUserCC extends Preference

	// invoke
	SecurityPreference{invoke.KycUserCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycUserCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycRuleCC extends Preference

	// invoke
	SecurityPreference{invoke.KycRuleCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycRuleCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycDocumentCC extends KeyValue

	// invoke
	SecurityPreference{invoke.KycDocumentCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycDocumentCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycDocumentStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycRuleStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.KycRuleStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycRuleStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// EthereumInputCC extends KeyValue

	// invoke
	SecurityPreference{invoke.EthereumInputCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumInputCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

}
